﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using System.Reflection;

namespace CloneSpread_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.Sheets.Count = 2;
            fpSpread1.Sheets[0].RowCount = 10;
            fpSpread1.Sheets[0].ColumnCount = 5;
            fpSpread1.Sheets[0].Cells[0, 0, fpSpread1.Sheets[0].RowCount - 1, fpSpread1.Sheets[0].ColumnCount - 1].Text = "Test 1";
            fpSpread1.Sheets[0].Columns[0].BackColor = Color.Aqua;
            fpSpread1.Sheets[0].Columns[2].BackColor = Color.AliceBlue;
            fpSpread1.Sheets[0].Columns[4].BackColor = Color.Cyan;
            fpSpread1.Sheets[1].RowCount = 10;
            fpSpread1.Sheets[1].ColumnCount = 5;
            fpSpread1.Sheets[1].Cells[0, 0, fpSpread1.Sheets[0].RowCount - 1, fpSpread1.Sheets[0].ColumnCount - 1].Text = "Test 2";
            fpSpread1.Sheets[1].Columns[1].BackColor = Color.Aqua;
            fpSpread1.Sheets[1].Columns[3].BackColor = Color.AliceBlue;
        }
        private void btnCloneSpread_Click(object sender, EventArgs e)
        {
            FpSpread clonedSpread = fpSpreadClone(fpSpread1);
            Controls.Add(clonedSpread);
            clonedSpread.Left = fpSpread1.Right;
            clonedSpread.Top = fpSpread1.Top;
            clonedSpread.Width = fpSpread1.Width;
            clonedSpread.Height = fpSpread1.Height;
        }
        private FpSpread fpSpreadClone(FpSpread baseObject)
        {
            //Copying to a memory stream
            System.IO.MemoryStream ms = new System.IO.MemoryStream();
            FarPoint.Win.Spread.Model.SpreadSerializer.SaveXml(fpSpread1, ms, false);
            ms = new System.IO.MemoryStream(ms.ToArray());

            //Copying from memory stream to clone spread object
            FarPoint.Win.Spread.FpSpread newSpread = new FarPoint.Win.Spread.FpSpread();
            FarPoint.Win.Spread.Model.SpreadSerializer.OpenXml(newSpread, ms);

         
            FieldInfo[] fInfo = typeof(FarPoint.Win.Spread.FpSpread).GetFields(BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Static);
            foreach (FieldInfo field in fInfo)
            {
                if (field != null)
                {
                    Delegate del = null;
                    if (field.FieldType.Name.Contains("EventHandler"))
                    {
                        del = (Delegate)field.GetValue(baseObject);
                    }

                    if (del != null)
                    {
                        EventInfo eInfo = typeof(FarPoint.Win.Spread.FpSpread).GetEvent(del.Method.Name.Substring(del.Method.Name.IndexOf('_') + 1));
                        if (eInfo != null)
                            eInfo.AddEventHandler(newSpread, del);
                    }
                }
            }

            return newSpread;
        }

        private void fpSpread1_CellClick(object sender, CellClickEventArgs e)
        {
            MessageBox.Show("You clicked cell " + e.Row +","+e.Column );  
        }

    }
}
